#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cctype>
#include <cstring>
#include <string>
#include <climits>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <list>
#include <ctime>

#define FOR(i, m, n) for (int i=m; i<n; i++)

using namespace std;

int batoh[1100][1100];
int vec[1100];
int N, M;

int main()
{
  FILE *fr, *fw;
  fr = fopen("vstup.in", "r");
  fw = fopen("vystup.out", "w");
  //fr = stdin; fw = stdout;
  
  fscanf(fr, "%d%d", &M, &N);
  FOR (i, 0, N) {
    fscanf(fr, "%d", &vec[i]);
  }
  // Inicializace batohu
  FOR (w, 0, M+1) FOR (x, 0, M+1) {
    batoh[w][x] = -1;
  }
  batoh[0][0] = 0;
  int A = INT_MIN; int B = INT_MIN; int C = INT_MIN;
  // Přidávání věcí
  FOR (k, 0, N) {
    for (int w=M; w>=vec[k]; w--) {
      for (int x=M; x>=0; x--) {
	if ((x^vec[k])<=M && batoh[w - vec[k]][x ^ vec[k]]>=0 && batoh[w][x]<batoh[w - vec[k]][x ^ vec[k]]+1) {
	  batoh[w][x] = batoh[w - vec[k]][x ^ vec[k]]+1;
	  if (A<w || (A==w && B<x) || (A==w && B==x && C<batoh[w][x])) {
	    A = w; B = x; C = batoh[w][x];
	  }
	}
      }
    }
  }
  
  fprintf(fw, "%d %d %d\n", A, B, C);
  
  fclose(fr);
  fclose(fw);
  return 0;
}
