#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cctype>
#include <cstring>
#include <string>
#include <climits>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <list>
#include <ctime>

#define FOR(i, m, n) for (int i=m; i<n; i++)

using namespace std;

#define MOD 1000000007

long long mocnina(long long a, long long b) {
  long long ret = 1;
  long long k = 1;
  long long h = a;
  while (k<=b) {
    if (k&b)
      ret = (ret*h)%MOD;
    h = (h*h)%MOD;
    k <<= 1;
  }
  return ret;
}

int main()
{
  FILE *fw, *fr;
  fr = fopen("vstup.in", "r");
  fw = fopen("vystup.out", "w");
  //fr = stdin; fw = stdout;
  long long a;
  long long b;
  fscanf(fr, "%lld%lld", &a, &b);
  fprintf(fw, "%lld\n", (MOD + mocnina(a, b) - mocnina(b, a))%MOD);
  fclose(fr);
  fclose(fw);
  return 0;
}
